# frozen_string_literal: true

module Hermes
  module BoClient
    # extending Mapping Module from base_map.rb
    module Mappings
      # handle HousingRequest model mapping for xml data send
      class FindNudMap
        include Hermes::BoClient::Mappings::Concerns::BaseMap
        def initialize(options)
          nud_id = options[:nud_id]
          self.main_object = Hermes::Nud.find_by(id: nud_id)
          @housing_request = Hermes::HousingRequest.find_by(id: main_object.housing_request_id)
          @map = {}
        end

        def numUnique
          main_object.unique_number
        end

        def civilite
          @housing_request.main_applicant&.civility
        end

        def nom
          @housing_request.requester_lastname
        end

        def prenom
          @housing_request.requester_firstname
        end

        def date_naissance
          @housing_request.requester_birth_date&.to_date
        end

        def commune_souhaitee
          @housing_request.seeked_districts
        end
      end
    end
  end
end
