require 'rails_helper'



# exemple d'utilisation ho = Hermes::HousingOffer.find("5def769722ec791f58770f6e")
=begin

l1 = Hermes::Lessor.create(title: 'MON ENTREPRISE', siren: 'plop')
a1 = Hermes::Entity.create(title: 'MON AGENCE', siren: 'replop', lessor: l1)
ho = Hermes::HousingOffer.create(lessor: l1,rent_amount: 1264.23,rental_charges: 56.73, agency_id: a1.id, als_siren:"123456789",mad_als_date: Date.current, availability_date: Date.current,designation_date_end: Date.current,  )

ho = Hermes::HousingOffer.find("5e0db0f4dfbd977046c72d93")
so=Hermes::BoClient::AddOfferTask.new({:'housing_offer_id'=> ho.id})
so.to_xml
ExecuteSopraTaskJob.perform_now(so.endpoint, so.to_xml)
=end

dir_path = File.dirname(__FILE__)
schema_path = [dir_path, 'FluxPatrimoine.xsd'].join('/')
require [Hermes::Engine.root, %w[lib hermes bo_client tasks]].flatten.join('/').to_s

RSpec.describe Hermes::BoClient::AddOfferTask, type: :helper do
  let!(:xsd) { Nokogiri::XML::Schema(File.read(schema_path)) }

  it 'should load a valid XSD' do
    expect(xsd).to be_present
    expect(xsd.class).to be Nokogiri::XML::Schema
  end

  context 'with simple housing_offer' do
    let!(:lessor1) { create(:lessor,
                            title: 'MON ENTREPRISE',
                            siren: '123456789',
                            siret: '123456789',
                            rpls_id:"dfqf"
    ) }
    let!(:responsible) {create(:user, roles: ['Administrator'])}
    let!(:agency1) { create(:entity, title: 'MON AGENCE', siren: '123456789', lessor: lessor1) }
    let!(:housing_offer1) do
      create(
        :housing_offer,
        lessor: lessor1,
        rent_amount: 1264.23,
        rental_charges: 56.73,
        agency_id: agency1.id,
        als_siren:"123456789",
        is_mad_updated_at: Date.current,
        availability_date: Date.current,
        designation_date_end: Date.current,
        has_gardian:false,
        lessor_orientation: "A",
        external_ref: "truc",
        description: "TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT",
        address: "fzefqezfzef",
        address_complements: "zeqfqzef",
        communicate_exact_address:true,
        postal_code: "30100",
        district:"Alès",
        virtual_visit: true,
        furnished_lodging: false,
        terraces_or_balconies: 2,
        already_inhabited: false,
        residence_code:"bibi",
        residence_title:"la charmille",
        qpv:true,
        construction_type:"T2",
      kind:"1",
        typology:"A"
      )
    end
    let!(:picture0) {create(:picture, housing_offer_id: housing_offer1.id.to_s, user_id: responsible.id)}
    let!(:picture1) {create(:picture, housing_offer_id: housing_offer1.id.to_s, user_id: responsible.id)}
    
    let!(:add_offer_task1) do
      
      build(
        :add_offer_task,
        options: { housing_offer_id: housing_offer1.id }
      )
    end

    describe 'using to_xml' do
      it 'should return a valid xml' do
        puts add_offer_task1.to_xml
         ap xsd.validate(Nokogiri::XML(add_offer_task1.to_xml))
        add_offer_task1.validate_xml
        expect(housing_offer1.reload.last_xml_validation_report).to eq("[]")
       expect(xsd.validate(Nokogiri::XML(add_offer_task1.to_xml)).length).to eq(0)
      end
    end
  end
end
